Subject: Re: tip tree clone fail

From: Wang Chen <[email-masked]>
Date: Mon, 13 Oct 2008 17:40:26 +0800

Ingo Molnar said the following on 2008-10-13 0:59:
> * Petr Baudis <[email-masked]> wrote:
> 
>> On Sun, Oct 12, 2008 at 05:24:27PM +0200, Ingo Molnar wrote:
>>> hm, -tip's .git/hooks/post-update already contained this, for the last 2 
>>> months:
>>>
>>>   exec git update-server-info
>>>
>>> so ... _despite_ us having this in the git repo, the HTTP protocol still 
>>> does not work. Why?
>> I think your problem is that HTTP does not know where to look for
>> objects coming from alternates; IIRC this would work if you used
>> relative paths in objects/info/alternates, or you can create
>> objects/info/http-alternates like
>>
>> 	/pub/scm/linux/kernel/git/torvalds/linux-2.6.git/objects
>> 	/pub/scm/linux/kernel/git/sfr/linux-next.git/objects
> 
> ok, i've now set it up like this:
> 
>  $ pwd
>  /pub/scm/linux/kernel/git/x86/linux-2.6-tip.git
> 
>  $ cat objects/info/alternates
>  /home/ftp/pub/scm/linux/kernel/git/torvalds/linux-2.6.git/objects
>  /home/ftp/pub/scm/linux/kernel/git/sfr/linux-next.git/objects
> 
>  $ cat objects/info/http-alternates
>  /pub/scm/linux/kernel/git/torvalds/linux-2.6.git/objects
>  /pub/scm/linux/kernel/git/sfr/linux-next.git/objects
> 
> and i've added "git update-server-info" to hooks/post-receive and made 
> it chmod +x.
> 
> that should be golden, right? I'm wondering why this isnt in the default 
> setup - i've been behind a limited corporate firewall in a former life 
> and having HTTP access is indeed very handy and pragmatic. Often hotel 
> WLANs are HTTP only as well.
> 
> Soapbox: in fact it would be outright stupid to limit the kernel 
> source's availability artificially by not making HTTP a tier-one access 
> method.
> 
> Fighting against HTTP-only firewalls is like constantly pointing it out 
> to the popular press that they should say 'cracker' instead of 'hacker'. 
> It is pointless and only hurts the availability our own project.
> 	

Ingo, thank you for your work.
I can clone more, but error still occurs:

Getting alternates list for http://www.kernel.org/pub/scm/linux/kernel/git/x86/linux-2.6-tip.git
Also look at http://www.kernel.org/pub/scm/linux/kernel/git/torvalds/linux-2.6.git/
Also look at http://www.kernel.org/pub/scm/linux/kernel/git/sfr/linux-next.git/
Getting pack list for http://www.kernel.org/pub/scm/linux/kernel/git/x86/linux-2.6-tip.git
error: transfer closed with 8280 bytes remaining to read
Getting pack list for http://www.kernel.org/pub/scm/linux/kernel/git/torvalds/linux-2.6.git/
Getting pack list for http://www.kernel.org/pub/scm/linux/kernel/git/sfr/linux-next.git/
error: Unable to find 95630fe2917f805a26f8d8beaafb80cd2f729eb5 under http://www.kernel.org/pub/scm/linux/kernel/git/x86/linux-2.6-tip.git
Cannot obtain needed object 95630fe2917f805a26f8d8beaafb80cd2f729eb5